Index: vtkvis/trunk/Contour2D.cpp
===================================================================
--- vtkvis/trunk/Contour2D.cpp	(revision 5072)
+++ vtkvis/trunk/Contour2D.cpp	(revision 5073)
@@ -314,30 +314,25 @@
         setColorMode(mode,
                      _dataSet->getActiveScalarsType(),
-                     _dataSet->getActiveScalarsName(),
-                     _dataRange);
+                     _dataSet->getActiveScalarsName());
         break;
     case COLOR_BY_VECTOR_MAGNITUDE:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorMagnitudeRange);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_X:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[0]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Y:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[1]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Z:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[2]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_CONSTANT:
Index: vtkvis/trunk/Contour3D.cpp
===================================================================
--- vtkvis/trunk/Contour3D.cpp	(revision 5072)
+++ vtkvis/trunk/Contour3D.cpp	(revision 5073)
@@ -279,30 +279,25 @@
         setColorMode(mode,
                      _dataSet->getActiveScalarsType(),
-                     _dataSet->getActiveScalarsName(),
-                     _dataRange);
+                     _dataSet->getActiveScalarsName());
         break;
     case COLOR_BY_VECTOR_MAGNITUDE:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorMagnitudeRange);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_X:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[0]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Y:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[1]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Z:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[2]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_CONSTANT:
Index: vtkvis/trunk/Cutplane.cpp
===================================================================
--- vtkvis/trunk/Cutplane.cpp	(revision 5072)
+++ vtkvis/trunk/Cutplane.cpp	(revision 5073)
@@ -566,30 +566,25 @@
         setColorMode(mode,
                      _dataSet->getActiveScalarsType(),
-                     _dataSet->getActiveScalarsName(),
-                     _dataRange);
+                     _dataSet->getActiveScalarsName());
         break;
     case COLOR_BY_VECTOR_MAGNITUDE:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorMagnitudeRange);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_X:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[0]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Y:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[1]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Z:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[2]);
+                     _dataSet->getActiveVectorsName());
         break;
     default:
Index: vtkvis/trunk/Glyphs.cpp
===================================================================
--- vtkvis/trunk/Glyphs.cpp	(revision 5072)
+++ vtkvis/trunk/Glyphs.cpp	(revision 5073)
@@ -714,26 +714,21 @@
     case COLOR_BY_SCALAR:
         setColorMode(mode,
-                     _dataSet->getActiveScalarsName(),
-                     _dataRange);
+                     _dataSet->getActiveScalarsName());
         break;
     case COLOR_BY_VECTOR_MAGNITUDE:
         setColorMode(mode,
-                     _dataSet->getActiveVectorsName(),
-                     _vectorMagnitudeRange);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_X:
         setColorMode(mode,
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[0]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Y:
         setColorMode(mode,
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[1]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Z:
         setColorMode(mode,
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[2]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_CONSTANT:
Index: vtkvis/trunk/HeightMap.cpp
===================================================================
--- vtkvis/trunk/HeightMap.cpp	(revision 5072)
+++ vtkvis/trunk/HeightMap.cpp	(revision 5073)
@@ -954,30 +954,25 @@
         setColorMode(mode,
                      _dataSet->getActiveScalarsType(),
-                     _dataSet->getActiveScalarsName(),
-                     _dataRange);
+                     _dataSet->getActiveScalarsName());
         break;
     case COLOR_BY_VECTOR_MAGNITUDE:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorMagnitudeRange);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_X:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[0]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Y:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[1]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Z:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[2]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_CONSTANT:
Index: vtkvis/trunk/Molecule.cpp
===================================================================
--- vtkvis/trunk/Molecule.cpp	(revision 5072)
+++ vtkvis/trunk/Molecule.cpp	(revision 5073)
@@ -349,30 +349,25 @@
         setColorMode(mode,
                      _dataSet->getActiveScalarsType(),
-                     _dataSet->getActiveScalarsName(),
-                     _dataRange);
+                     _dataSet->getActiveScalarsName());
         break;
     case COLOR_BY_VECTOR_MAGNITUDE:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorMagnitudeRange);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_X:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[0]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Y:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[1]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Z:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[2]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_CONSTANT:
Index: vtkvis/trunk/PolyData.cpp
===================================================================
--- vtkvis/trunk/PolyData.cpp	(revision 5072)
+++ vtkvis/trunk/PolyData.cpp	(revision 5073)
@@ -342,30 +342,25 @@
         setColorMode(mode,
                      _dataSet->getActiveScalarsType(),
-                     _dataSet->getActiveScalarsName(),
-                     _dataRange);
+                     _dataSet->getActiveScalarsName());
         break;
     case COLOR_BY_VECTOR_MAGNITUDE:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorMagnitudeRange);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_X:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[0]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Y:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[1]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Z:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[2]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_CONSTANT:
Index: vtkvis/trunk/PseudoColor.cpp
===================================================================
--- vtkvis/trunk/PseudoColor.cpp	(revision 5072)
+++ vtkvis/trunk/PseudoColor.cpp	(revision 5073)
@@ -312,30 +312,25 @@
         setColorMode(mode,
                      _dataSet->getActiveScalarsType(),
-                     _dataSet->getActiveScalarsName(),
-                     _dataRange);
+                     _dataSet->getActiveScalarsName());
         break;
     case COLOR_BY_VECTOR_MAGNITUDE:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorMagnitudeRange);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_X:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[0]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Y:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[1]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Z:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[2]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_CONSTANT:
Index: vtkvis/trunk/Streamlines.cpp
===================================================================
--- vtkvis/trunk/Streamlines.cpp	(revision 5072)
+++ vtkvis/trunk/Streamlines.cpp	(revision 5073)
@@ -1460,30 +1460,25 @@
         setColorMode(mode,
                      _dataSet->getActiveScalarsType(),
-                     _dataSet->getActiveScalarsName(),
-                     _dataRange);
+                     _dataSet->getActiveScalarsName());
         break;
     case COLOR_BY_VECTOR_MAGNITUDE:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorMagnitudeRange);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_X:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[0]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Y:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[1]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Z:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[2]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_CONSTANT:
Index: vtkvis/trunk/Warp.cpp
===================================================================
--- vtkvis/trunk/Warp.cpp	(revision 5072)
+++ vtkvis/trunk/Warp.cpp	(revision 5073)
@@ -359,30 +359,25 @@
         setColorMode(mode,
                      _dataSet->getActiveScalarsType(),
-                     _dataSet->getActiveScalarsName(),
-                     _dataRange);
+                     _dataSet->getActiveScalarsName());
         break;
     case COLOR_BY_VECTOR_MAGNITUDE:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorMagnitudeRange);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_X:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[0]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Y:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[1]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_BY_VECTOR_Z:
         setColorMode(mode,
                      _dataSet->getActiveVectorsType(),
-                     _dataSet->getActiveVectorsName(),
-                     _vectorComponentRange[2]);
+                     _dataSet->getActiveVectorsName());
         break;
     case COLOR_CONSTANT: