Index: branches/1.4/gui/scripts/visviewer.tcl
===================================================================
--- branches/1.4/gui/scripts/visviewer.tcl	(revision 5095)
+++ branches/1.4/gui/scripts/visviewer.tcl	(revision 5096)
@@ -57,4 +57,6 @@
     protected variable _debugConsole 0
     protected variable _reportClientInfo 1
+    # Number of milliscends to wait for server reply before displaying wait
+    # dialog.  If set to 0, dialog is never displayed.
     protected variable _waitTimeout 0
 
@@ -96,5 +98,4 @@
     protected method SendBytes { bytes }
     protected method SendCmd {string}
-    protected method SendCmdNoWait {string}
     protected method SendEcho { channel {data ""} }
     protected method StartBufferingCommands {}
@@ -478,7 +479,6 @@
 # StartWaiting --
 #
-#    Read some number of bytes from the visualization server.
-#
-
+#    Display a waiting dialog after a timeout has passed
+#
 itcl::body Rappture::VisViewer::StartWaiting {} {
     if { $_waitTimeout > 0 } {
@@ -488,4 +488,9 @@
 }
 
+#
+# StopWaiting --
+#
+#    Take down waiting dialog
+#
 itcl::body Rappture::VisViewer::StopWaiting {} {
     if { $_waitTimeout > 0 } {
@@ -1180,17 +1185,2 @@
     }
 }
-
-#
-# SendCmdNoWait
-#
-#       Send commands off to the rendering server.  If we're currently
-#       sending data objects to the server, buffer the commands to be
-#       sent later.
-#
-itcl::body Rappture::VisViewer::SendCmdNoWait {string} {
-    if { $_buffering } {
-        append _outbuf $string "\n"
-    } else {
-        SendBytes "$string\n"
-    }
-}
Index: branches/1.4/gui/scripts/vtkglyphviewer.tcl
===================================================================
--- branches/1.4/gui/scripts/vtkglyphviewer.tcl	(revision 5095)
+++ branches/1.4/gui/scripts/vtkglyphviewer.tcl	(revision 5096)
@@ -1565,5 +1565,5 @@
     if { $_currentColormap != ""  } {
         set cmap $_currentColormap
-        SendCmdNoWait "legend $cmap $_colorMode $_curFldName {} $w $h 0"
+        SendCmd "legend $cmap $_colorMode $_curFldName {} $w $h 0"
     }
 }
Index: branches/1.4/gui/scripts/vtkisosurfaceviewer.tcl
===================================================================
--- branches/1.4/gui/scripts/vtkisosurfaceviewer.tcl	(revision 5095)
+++ branches/1.4/gui/scripts/vtkisosurfaceviewer.tcl	(revision 5096)
@@ -1690,5 +1690,5 @@
     if { $_currentColormap != ""  } {
         set cmap $_currentColormap
-        SendCmdNoWait "legend $cmap scalar $_curFldName {} $w $h 0"
+        SendCmd "legend $cmap scalar $_curFldName {} $w $h 0"
     }
 }
Index: branches/1.4/gui/scripts/vtkstreamlinesviewer.tcl
===================================================================
--- branches/1.4/gui/scripts/vtkstreamlinesviewer.tcl	(revision 5095)
+++ branches/1.4/gui/scripts/vtkstreamlinesviewer.tcl	(revision 5096)
@@ -1239,5 +1239,5 @@
 itcl::body Rappture::VtkStreamlinesViewer::Pick {x y} {
     foreach tag [CurrentDatasets -visible] {
-        SendCmdNoWait "dataset getscalar pixel $x $y $tag"
+        SendCmd "dataset getscalar pixel $x $y $tag"
     }
 }
@@ -1523,5 +1523,5 @@
         foreach {dataobj comp} [split $dataset -] break
         if { [info exists _dataset2style($dataset)] } {
-            SendCmdNoWait \
+            SendCmd \
                 "legend $_dataset2style($dataset) $_colorMode $_curFldName {} $w $h 0"
             break;
Index: branches/1.4/gui/scripts/vtksurfaceviewer.tcl
===================================================================
--- branches/1.4/gui/scripts/vtksurfaceviewer.tcl	(revision 5095)
+++ branches/1.4/gui/scripts/vtksurfaceviewer.tcl	(revision 5096)
@@ -1476,5 +1476,5 @@
     if { $_currentColormap != ""  } {
         set cmap $_currentColormap
-        SendCmdNoWait "legend $cmap scalar $_curFldName {} $w $h 0"
+        SendCmd "legend $cmap scalar $_curFldName {} $w $h 0"
     }
 }
Index: branches/1.4/gui/scripts/vtkvolumeviewer.tcl
===================================================================
--- branches/1.4/gui/scripts/vtkvolumeviewer.tcl	(revision 5095)
+++ branches/1.4/gui/scripts/vtkvolumeviewer.tcl	(revision 5096)
@@ -1541,5 +1541,5 @@
         foreach {dataobj comp} [split $dataset -] break
         if { [info exists _dataset2style($dataset)] } {
-            SendCmdNoWait \
+            SendCmd \
                 "legend2 $_dataset2style($dataset) $w $h"
                 #"legend $_dataset2style($dataset) $_colorMode $_curFldName {} $w $h 0"