Index: /trunk/gui/scripts/vtkglyphviewer.tcl
===================================================================
--- /trunk/gui/scripts/vtkglyphviewer.tcl	(revision 5155)
+++ /trunk/gui/scripts/vtkglyphviewer.tcl	(revision 5156)
@@ -132,6 +132,5 @@
     private variable _changed
     private variable _initialStyle;     # Array of initial component styles.
-    private variable _reset 1;          # indicates if camera needs to be reset
-                                        # to starting position.
+    private variable _reset 1;          # Connection to server has been reset.
 
     private variable _first ""     ;    # This is the topmost dataset.
@@ -769,4 +768,5 @@
         return 0
     }
+    set _reset 1
     set result [VisViewer::Connect $_hosts]
     if { $result } {
@@ -1056,8 +1056,8 @@
         Zoom reset
         foreach axis { x y z } {
-            # Another problem fixed by a <view>. We looking into a data
-            # object for the name of the axes. This should be global to
-            # the viewer itself.
-            set label [$_first hints ${axis}label]
+            set label ""
+            if { $_first != "" } {
+                set label [$_first hints ${axis}label]
+            }
             if { $label == "" } {
                 set label [string toupper $axis]
Index: /trunk/gui/scripts/vtkheightmapviewer.tcl
===================================================================
--- /trunk/gui/scripts/vtkheightmapviewer.tcl	(revision 5155)
+++ /trunk/gui/scripts/vtkheightmapviewer.tcl	(revision 5156)
@@ -139,8 +139,5 @@
     private variable _changed
     private variable _initialStyle "";  # First found style in dataobjects.
-    private variable _reset 1;          # Indicates if the connection to the 
-                                        # render server was reset
-    private variable _beforeConnect 1;  # Indicates if we are in the constructor
-                                        # before the server connection is made
+    private variable _reset 1;          # Connection to server has been reset.
 
     private variable _first ""     ;    # This is the topmost dataset.
@@ -409,5 +406,4 @@
     eval itk_initialize $args
     Connect
-    set _beforeConnect 0
 }
 
@@ -747,9 +743,9 @@
     global readyForNextFrame
     set readyForNextFrame 1
-    set _reset 1
     set _hosts [GetServerList "vtkvis"]
     if { "" == $_hosts } {
         return 0
     }
+    set _reset 1
     set result [VisViewer::Connect $_hosts]
     if { $result } {
@@ -1368,5 +1364,5 @@
 #
 itcl::body Rappture::VtkHeightmapViewer::AdjustSetting {what {value ""}} {
-    if { $_beforeConnect } {
+    if { ![isconnected] } {
         return
     }
Index: /trunk/gui/scripts/vtkimageviewer.tcl
===================================================================
--- /trunk/gui/scripts/vtkimageviewer.tcl	(revision 5155)
+++ /trunk/gui/scripts/vtkimageviewer.tcl	(revision 5156)
@@ -134,8 +134,5 @@
     private variable _changed
     private variable _initialStyle "";  # First found style in dataobjects.
-    private variable _reset 1;          # Indicates if camera needs to be reset
-                                        # to starting position.
-    private variable _beforeConnect 1;  # Indicates if camera needs to be reset
-                                        # to starting position.
+    private variable _reset 1;          # Connection to server has been reset.
 
     private variable _first ""     ;    # This is the topmost dataset.
@@ -399,5 +396,4 @@
     EnableWaitDialog 900
     Connect
-    set _beforeConnect 0
 }
 
@@ -737,9 +733,9 @@
     global readyForNextFrame
     set readyForNextFrame 1
-    set _reset 1
     set _hosts [GetServerList "vtkvis"]
     if { "" == $_hosts } {
         return 0
     }
+    set _reset 1
     set result [VisViewer::Connect $_hosts]
     if { $result } {
@@ -1028,5 +1024,8 @@
 
         foreach axis { x y z } {
-            set label [$_first hints ${axis}label]
+            set label ""
+            if { $_first != "" } {
+                set label [$_first hints ${axis}label]
+            }
             if { $label == "" } {
                 set label [string toupper $axis]
@@ -1035,10 +1034,13 @@
             SendCmd [list axis name $axis $label]
 
-            if {$axis == "z" && [$_first hints ${axis}units] == ""} {
-                if {$_curFldName != ""} {
-                    set units [lindex $_fields($_curFldName) 1]
-                }
-            } else {
-                set units [$_first hints ${axis}units]
+            set units ""
+            if { $_first != "" } {
+                if {$axis == "z" && [$_first hints ${axis}units] == ""} {
+                    if {$_curFldName != ""} {
+                        set units [lindex $_fields($_curFldName) 1]
+                    }
+                } else {
+                    set units [$_first hints ${axis}units]
+                }
             }
             if { $units != "" } {
@@ -1309,5 +1311,5 @@
 #
 itcl::body Rappture::VtkImageViewer::AdjustSetting {what {value ""}} {
-    if { $_beforeConnect } {
+    if { ![isconnected] } {
         return
     }
Index: /trunk/gui/scripts/vtkisosurfaceviewer.tcl
===================================================================
--- /trunk/gui/scripts/vtkisosurfaceviewer.tcl	(revision 5155)
+++ /trunk/gui/scripts/vtkisosurfaceviewer.tcl	(revision 5156)
@@ -149,6 +149,5 @@
     private variable _changed
     private variable _initialStyle;     # Array of initial component styles.
-    private variable _reset 1;          # indicates if camera needs to be reset
-                                        # to starting position.
+    private variable _reset 1;          # Connection to server has been reset.
 
     private variable _first ""     ;    # This is the topmost dataset.
@@ -881,4 +880,5 @@
         return 0
     }
+    set _reset 1
     set result [VisViewer::Connect $_hosts]
     if { $result } {
@@ -1139,8 +1139,8 @@
         Zoom reset
         foreach axis { x y z } {
-            # Another problem fixed by a <view>. We looking into a data
-            # object for the name of the axes. This should be global to
-            # the viewer itself.
-            set label [$_first hints ${axis}label]
+            set label ""
+            if { $_first != "" } {
+                set label [$_first hints ${axis}label]
+            }
             if { $label == "" } {
                 set label [string toupper $axis]
Index: /trunk/gui/scripts/vtkmeshviewer.tcl
===================================================================
--- /trunk/gui/scripts/vtkmeshviewer.tcl	(revision 5155)
+++ /trunk/gui/scripts/vtkmeshviewer.tcl	(revision 5156)
@@ -115,6 +115,5 @@
     private variable _style;            # Array of current component styles.
     private variable _initialStyle;     # Array of initial component styles.
-    private variable _reset 1;          # Indicates that server was reset and
-                                        # needs to be reinitialized.
+    private variable _reset 1;          # Connection to server has been reset.
 
     private variable _first "";         # This is the topmost dataset.
@@ -652,4 +651,5 @@
         return 0
     }
+    set _reset 1
     set result [VisViewer::Connect $_hosts]
     if { $result } {
Index: /trunk/gui/scripts/vtkstreamlinesviewer.tcl
===================================================================
--- /trunk/gui/scripts/vtkstreamlinesviewer.tcl	(revision 5155)
+++ /trunk/gui/scripts/vtkstreamlinesviewer.tcl	(revision 5156)
@@ -130,6 +130,5 @@
     private variable _style;            # Array of current component styles.
     private variable _initialStyle;     # Array of initial component styles.
-    private variable _reset 1;          # indicates if camera needs to be reset
-                                        # to starting position.
+    private variable _reset 1;          # Connection to server has been reset.
 
     private variable _first ""     ;    # This is the topmost dataset.
@@ -782,4 +781,5 @@
         return 0
     }
+    set _reset 1
     set result [VisViewer::Connect $_hosts]
     if { $result } {
Index: /trunk/gui/scripts/vtksurfaceviewer.tcl
===================================================================
--- /trunk/gui/scripts/vtksurfaceviewer.tcl	(revision 5155)
+++ /trunk/gui/scripts/vtksurfaceviewer.tcl	(revision 5156)
@@ -131,6 +131,5 @@
     private variable _changed
     private variable _initialStyle;     # Array of initial component styles.
-    private variable _reset 1;          # indicates if camera needs to be reset
-                                        # to starting position.
+    private variable _reset 1;          # Connection to server has been reset.
 
     private variable _first ""     ;    # This is the topmost dataset.
@@ -719,4 +718,5 @@
         return 0
     }
+    set _reset 1
     set result [VisViewer::Connect $_hosts]
     if { $result } {
@@ -1000,8 +1000,8 @@
         Zoom reset
         foreach axis { x y z } {
-            # Another problem fixed by a <view>. We looking into a data
-            # object for the name of the axes. This should be global to
-            # the viewer itself.
-            set label [$_first hints ${axis}label]
+            set label ""
+            if { $_first != "" } {
+                set label [$_first hints ${axis}label]
+            }
             if { $label == "" } {
                 set label [string toupper $axis]
Index: /trunk/gui/scripts/vtkviewer.tcl
===================================================================
--- /trunk/gui/scripts/vtkviewer.tcl	(revision 5155)
+++ /trunk/gui/scripts/vtkviewer.tcl	(revision 5156)
@@ -142,6 +142,5 @@
     private variable _initialStyle;     # Array of initial component styles.
     private variable _axis
-    private variable _reset 1;          # Indicates that server was reset and
-                                        # needs to be reinitialized.
+    private variable _reset 1;          # Connection to server has been reset.
     private variable _haveGlyphs 0
     private variable _haveMolecules 0
@@ -865,4 +864,5 @@
         return 0
     }
+    set _reset 1
     set result [VisViewer::Connect $_hosts]
     if { $result } {
Index: /trunk/gui/scripts/vtkvolumeviewer.tcl
===================================================================
--- /trunk/gui/scripts/vtkvolumeviewer.tcl	(revision 5155)
+++ /trunk/gui/scripts/vtkvolumeviewer.tcl	(revision 5156)
@@ -155,6 +155,5 @@
     private variable _style;            # Array of current component styles.
     private variable _initialStyle;     # Array of initial component styles.
-    private variable _reset 1;          # indicates if camera needs to be reset
-                                        # to starting position.
+    private variable _reset 1;          # Connection to server has been reset.
 
     private variable _first ""     ;    # This is the topmost dataset.
@@ -817,4 +816,5 @@
         return 0
     }
+    set _reset 1
     set result [VisViewer::Connect $_hosts]
     if { $result } {
@@ -898,5 +898,4 @@
     set _cutplanePending 0
     set _legendPending 0
-    set _reset 1
 }
 
@@ -1372,8 +1371,4 @@
 itcl::body Rappture::VtkVolumeViewer::AdjustSetting {what {value ""}} {
     if { ![isconnected] } {
-        if { $_reset } {
-            # Just reconnect if we've been reset.
-            Connect
-        }
         return
     }